diff --git a/doc/guides/cryptodevs/armv8.rst b/doc/guides/cryptodevs/armv8.rst
index 8963f66a206c..1a006754cbe4 100644
--- a/doc/guides/cryptodevs/armv8.rst
+++ b/doc/guides/cryptodevs/armv8.rst
@@ -47,7 +47,7 @@ To build DPDK with this virtual crypto PMD, the user is required to:
 
 .. code-block:: console
 
-   meson build
+   meson setup build
    ninja -C build
 
 The corresponding device can be created only if the following features
diff --git a/doc/guides/cryptodevs/uadk.rst b/doc/guides/cryptodevs/uadk.rst
index 1325eaca3f0a..9af6b88a5a54 100644
--- a/doc/guides/cryptodevs/uadk.rst
+++ b/doc/guides/cryptodevs/uadk.rst
@@ -87,7 +87,7 @@ Test steps
 
       cd dpdk
       mkdir build
-      meson build (--reconfigure)
+      meson setup build (--reconfigure)
       cd build
       ninja
       sudo ninja install
diff --git a/doc/guides/freebsd_gsg/build_dpdk.rst b/doc/guides/freebsd_gsg/build_dpdk.rst
index d335b97cfc1e..514d18c8700e 100644
--- a/doc/guides/freebsd_gsg/build_dpdk.rst
+++ b/doc/guides/freebsd_gsg/build_dpdk.rst
@@ -44,7 +44,7 @@ Building DPDK
 The following commands can be used to build and install DPDK on a system.
 The final, install, step generally needs to be run as root::
 
-  meson build
+  meson setup build
   cd build
   ninja
   ninja install
diff --git a/doc/guides/gpus/cuda.rst b/doc/guides/gpus/cuda.rst
index 55fc7d1e8626..dc5b0aa603c4 100644
--- a/doc/guides/gpus/cuda.rst
+++ b/doc/guides/gpus/cuda.rst
@@ -25,7 +25,7 @@ Three ways:
 
 - Set ``export CFLAGS=-I/usr/local/cuda/include`` before building
 - Add CFLAGS in the meson command line ``CFLAGS=-I/usr/local/cuda/include meson build``
-- Add the ``-Dc_args`` in meson command line ``meson build -Dc_args=-I/usr/local/cuda/include``
+- Add the ``-Dc_args`` in meson command line ``meson setup build -Dc_args=-I/usr/local/cuda/include``
 
 If headers are not found, the CUDA GPU driver library is not built.
 
@@ -51,7 +51,7 @@ An example would be:
 
 .. code-block:: console
 
-  $ meson build -Dc_args="-I/usr/local/cuda/include -I/path/to/gdrcopy/include"
+  $ meson setup build -Dc_args="-I/usr/local/cuda/include -I/path/to/gdrcopy/include"
 
 If headers are not found, the CUDA GPU driver library is built without the CPU map capability
 and will return error if the application invokes the gpudev ``rte_gpu_mem_cpu_map`` function.
diff --git a/doc/guides/howto/openwrt.rst b/doc/guides/howto/openwrt.rst
index e1d7db2a9054..8a9155ebf457 100644
--- a/doc/guides/howto/openwrt.rst
+++ b/doc/guides/howto/openwrt.rst
@@ -100,8 +100,8 @@ first.
     ar = 'x86_64-openwrt-linux-ar'
     strip = 'x86_64-openwrt-linux-strip'
 
-    meson builddir --cross-file openwrt-cross
-    ninja -C builddir
+    meson setup build --cross-file openwrt-cross
+    ninja -C build
 
 Running DPDK application on OpenWrt
 -----------------------------------
diff --git a/doc/guides/nics/ark.rst b/doc/guides/nics/ark.rst
index 591e41799ca0..ba00f14e8029 100644
--- a/doc/guides/nics/ark.rst
+++ b/doc/guides/nics/ark.rst
@@ -282,7 +282,7 @@ CFLAGS environment prior to the meson build step. I.e.,
 .. code-block:: console
 
     export CFLAGS="-DRTE_LIBRTE_ARK_MIN_TX_PKTLEN=60"
-    meson build
+    meson setup build
 
 
 Supported ARK RTL PCIe Instances
diff --git a/doc/guides/nics/mvneta.rst b/doc/guides/nics/mvneta.rst
index b7f279c3cb16..2ee2637a58f3 100644
--- a/doc/guides/nics/mvneta.rst
+++ b/doc/guides/nics/mvneta.rst
@@ -117,7 +117,7 @@ Add path to libmusdk.pc in PKG_CONFIG_PATH environment variable.
 .. code-block:: console
 
    export PKG_CONFIG_PATH=$<musdk_install_dir>/lib/pkgconfig/:$PKG_CONFIG_PATH
-   meson build --cross-file config/arm/arm64_armada_linux_gcc
+   meson setup build --cross-file config/arm/arm64_armada_linux_gcc
    ninja -C build
 
 
diff --git a/doc/guides/nics/mvpp2.rst b/doc/guides/nics/mvpp2.rst
index e40fed72868c..cbfa47afd870 100644
--- a/doc/guides/nics/mvpp2.rst
+++ b/doc/guides/nics/mvpp2.rst
@@ -133,7 +133,7 @@ Add path to libmusdk.pc in PKG_CONFIG_PATH environment variable.
 
    export PKG_CONFIG_PATH=$<musdk_install_dir>/lib/pkgconfig/:$PKG_CONFIG_PATH
 
-   meson build --cross-file config/arm/arm64_armada_linux_gcc
+   meson setup build --cross-file config/arm/arm64_armada_linux_gcc
    ninja -C build
 
 
diff --git a/doc/guides/platform/bluefield.rst b/doc/guides/platform/bluefield.rst
index 3e3078c85e69..09486747b12f 100644
--- a/doc/guides/platform/bluefield.rst
+++ b/doc/guides/platform/bluefield.rst
@@ -61,7 +61,7 @@ rdma-core library with corresponding kernel drivers is required.
 
 .. code-block:: console
 
-        meson build
+        meson setup build
         ninja -C build
 
 Cross Compilation
@@ -115,5 +115,5 @@ Then, untar the tarball at the cross toolchain directory on the x86 host.
 
 .. code-block:: console
 
-        meson build --cross-file config/arm/arm64_bluefield_linux_gcc
+        meson setup build --cross-file config/arm/arm64_bluefield_linux_gcc
         ninja -C build
diff --git a/doc/guides/platform/cnxk.rst b/doc/guides/platform/cnxk.rst
index 562ed7d7a6cd..f2de6bb5963d 100644
--- a/doc/guides/platform/cnxk.rst
+++ b/doc/guides/platform/cnxk.rst
@@ -606,14 +606,14 @@ CN9K:
 
 .. code-block:: console
 
-        meson build --cross-file config/arm/arm64_cn9k_linux_gcc
+        meson setup build --cross-file config/arm/arm64_cn9k_linux_gcc
         ninja -C build
 
 CN10K:
 
 .. code-block:: console
 
-        meson build --cross-file config/arm/arm64_cn10k_linux_gcc
+        meson setup build --cross-file config/arm/arm64_cn10k_linux_gcc
         ninja -C build
 
 .. note::
diff --git a/doc/guides/platform/octeontx.rst b/doc/guides/platform/octeontx.rst
index 42ddb1762efa..1459dc7109be 100644
--- a/doc/guides/platform/octeontx.rst
+++ b/doc/guides/platform/octeontx.rst
@@ -94,14 +94,14 @@ drivers can be compiled with the following steps,
 
 .. code-block:: console
 
-        meson build -Dexamples=<application>
+        meson setup build -Dexamples=<application>
         ninja -C build
 
 The example applications can be compiled using the following:
 
 .. code-block:: console
 
-        meson build -Dexamples=<application>
+        meson setup build -Dexamples=<application>
         ninja -C build
 
 Cross Compilation
@@ -127,7 +127,7 @@ Now this build system can be used to build applications for **OCTEON TX** :sup:`
 .. code-block:: console
 
         cd <dpdk directory>
-        meson build --cross-file config/arm/arm64_thunderx_linux_gcc
+        meson setup build --cross-file config/arm/arm64_thunderx_linux_gcc
         ninja -C build
 
 The example applications can be compiled using the following:
@@ -135,7 +135,7 @@ The example applications can be compiled using the following:
 .. code-block:: console
 
         cd <dpdk directory>
-        meson build --cross-file config/arm/arm64_thunderx_linux_gcc -Dexamples=<application>
+        meson setup build --cross-file config/arm/arm64_thunderx_linux_gcc -Dexamples=<application>
         ninja -C build
 
 .. note::
diff --git a/doc/guides/prog_guide/build-sdk-meson.rst b/doc/guides/prog_guide/build-sdk-meson.rst
index 58d9b553a0e2..c1d738e02f42 100644
--- a/doc/guides/prog_guide/build-sdk-meson.rst
+++ b/doc/guides/prog_guide/build-sdk-meson.rst
@@ -9,7 +9,7 @@ Summary
 For many platforms, compiling and installing DPDK should work using the
 following set of commands::
 
-	meson build
+	meson setup build
 	cd build
 	ninja
 	ninja install
@@ -57,7 +57,7 @@ Configuring the Build
 ----------------------
 
 To configure a build, run the meson tool, passing the path to the directory
-to be used for the build e.g. ``meson build``, as shown above. If calling
+to be used for the build e.g. ``meson setup build``, as shown above. If calling
 meson from somewhere other than the root directory of the DPDK project the
 path to the root directory should be passed as the first parameter, and the
 build path as the second. For example, to build DPDK in /tmp/dpdk-build::
diff --git a/doc/guides/prog_guide/lto.rst b/doc/guides/prog_guide/lto.rst
index f79c449598b0..ff9f47a8f4ee 100644
--- a/doc/guides/prog_guide/lto.rst
+++ b/doc/guides/prog_guide/lto.rst
@@ -30,4 +30,4 @@ Link time optimization can be enabled by setting meson built-in 'b_lto' option:
 
 .. code-block:: console
 
-    meson build -Db_lto=true
+    meson setup build -Db_lto=true
diff --git a/doc/guides/prog_guide/profile_app.rst b/doc/guides/prog_guide/profile_app.rst
index bd6700ef850b..0aff6c18a2ae 100644
--- a/doc/guides/prog_guide/profile_app.rst
+++ b/doc/guides/prog_guide/profile_app.rst
@@ -42,7 +42,7 @@ and recompile the DPDK:
 
 .. code-block:: console
 
-   meson build
+   meson setup build
    meson configure build -Dc_args=-DRTE_ETHDEV_PROFILE_WITH_VTUNE
    ninja -C build
 
diff --git a/doc/guides/sample_app_ug/vm_power_management.rst b/doc/guides/sample_app_ug/vm_power_management.rst
index 9ce87956c9fb..ca7d38d0dfd1 100644
--- a/doc/guides/sample_app_ug/vm_power_management.rst
+++ b/doc/guides/sample_app_ug/vm_power_management.rst
@@ -255,11 +255,10 @@ To build just the ``vm_power_manager`` application using ``meson``/``ninja``:
 .. code-block:: console
 
    cd dpdk
-   meson build
-   cd build
-   ninja
+   meson setup build
+   ninja -C build
    meson configure -Dexamples=vm_power_manager
-   ninja
+   ninja -C build
 
 The resulting binary is ``dpdk/build/examples/dpdk-vm_power_manager``.
 
@@ -494,11 +493,10 @@ To build just the ``vm_power_manager`` application using ``meson``/``ninja``:
 .. code-block:: console
 
    cd dpdk
-   meson build
-   cd build
-   ninja
+   meson setup build
+   ninja -C build
    meson configure -Dexamples=vm_power_manager/guest_cli
-   ninja
+   ninja -C build
 
 The resulting binary is ``dpdk/build/examples/guest_cli``.
 